"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createElement = exports.isElement = void 0;
var isFunction_1 = require("../helpers/isFunction");
var ELEMENT_TYPE = 're-element';
var Element = function (type, props) {
    var elementName = isFunction_1.isFunction(type) ? type['displayName'] || type.name : type;
    return ({ _n: elementName,
        _type: ELEMENT_TYPE, type: type,
        props: props
    });
};
exports.isElement = function (value) {
    return value && value._type == ELEMENT_TYPE;
};
var EMPTY_CHILDREN = [];
exports.createElement = function (type, props) {
    var children = [];
    for (var _i = 2; _i < arguments.length; _i++) {
        children[_i - 2] = arguments[_i];
    }
    if (props == null) {
        props = Object.create(null);
    }
    props.children = children || EMPTY_CHILDREN;
    return Element(type, props);
};
