"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createObservableComponent = void 0;
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var DynamicEntry_1 = require("../DynamicEntry");
var helpers_1 = require("./helpers");
function createObservableComponent() {
    var update$ = new rxjs_1.Subject();
    var destroy$ = new rxjs_1.Subject();
    var dynamicChild = DynamicEntry_1.DynamicEntry();
    destroy$.pipe(operators_1.take(1))
        .subscribe(dynamicChild.destroy$);
    update$
        .pipe(operators_1.switchMap(function (a) { return a; }), operators_1.takeUntil(destroy$))
        .subscribe(dynamicChild.update$);
    return {
        type: helpers_1.ComponentType.observable,
        update$: update$,
        destroy$: destroy$,
        result$: dynamicChild.result$
    };
}
exports.createObservableComponent = createObservableComponent;
