"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createStaticComponent = void 0;
var tslib_1 = require("tslib");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var DynamicEntry_1 = require("../DynamicEntry");
var helpers_1 = require("./helpers");
exports.createStaticComponent = function (element) {
    var update$ = new rxjs_1.ReplaySubject(1);
    var destroy$ = new rxjs_1.Subject();
    var element$ = new rxjs_1.Subject();
    var dynamicChildren = element.props.children
        .map(function () { return DynamicEntry_1.DynamicEntry(); });
    destroy$.pipe(operators_1.take(1)).subscribe(function () {
        dynamicChildren.forEach(function (child) { return child.destroy$.next(void 0); });
        element$.complete();
    });
    dynamicChildren.forEach(function (child, i) {
        update$.pipe(operators_1.map(function (update) { return update.props.children[i]; }), operators_1.takeUntil(destroy$)).subscribe(child.update$);
    });
    rxjs_1.combineLatest(update$.pipe(operators_1.map(function (definition) { return definition.props.ref; }), operators_1.filter(function (x) { return !!x; })), element$).pipe(operators_1.takeUntil(destroy$)).subscribe(function (_a) {
        var _b = tslib_1.__read(_a, 2), ref = _b[0], element = _b[1];
        ref.next(element);
    });
    var change$ = update$.pipe(operators_1.map(function (definition) { return definition.props; }), operators_1.takeUntil(destroy$));
    return {
        type: helpers_1.ComponentType.static,
        update$: update$,
        element$: element$,
        definition: element,
        dynamicChildren: dynamicChildren,
        change$: change$,
        destroy$: destroy$,
    };
};
