"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getType = exports.ComponentType = void 0;
var rxjs_1 = require("rxjs");
var isThenable_1 = require("../../helpers/isThenable");
var isFunction_1 = require("../../helpers/isFunction");
var isArray_1 = require("../../helpers/isArray");
var Element_1 = require("../Element");
var ComponentType;
(function (ComponentType) {
    ComponentType["leaf"] = "leaf";
    ComponentType["fn"] = "fn";
    ComponentType["array"] = "array";
    ComponentType["observable"] = "observable";
    ComponentType["static"] = "static";
})(ComponentType = exports.ComponentType || (exports.ComponentType = {}));
function getType(child) {
    if (rxjs_1.isObservable(child) || isThenable_1.isThenable(child)) {
        return ComponentType.observable;
    }
    else if (isArray_1.isArray(child)) {
        return ComponentType.array;
    }
    else if (Element_1.isElement(child)) {
        if (typeof child.type == 'string') {
            return ComponentType.static;
        }
        else if (isFunction_1.isFunction(child.type)) {
            return ComponentType.fn;
        }
    }
    return ComponentType.leaf;
}
exports.getType = getType;
