"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createComponent = void 0;
var tslib_1 = require("tslib");
var Array_1 = require("./Array");
var Fn_1 = require("./Fn");
var helpers_1 = require("./helpers");
var Leaf_1 = require("./Leaf");
var Observable_1 = require("./Observable");
var Static_1 = require("./Static");
tslib_1.__exportStar(require("./helpers"), exports);
// A component listens to definition updates
// and maps that to self updates and children updates
exports.createComponent = function (child) {
    var type = helpers_1.getType(child);
    switch (type) {
        case helpers_1.ComponentType.leaf: return Leaf_1.createLeafComponent(child);
        case helpers_1.ComponentType.observable: return Observable_1.createObservableComponent();
        case helpers_1.ComponentType.array: return Array_1.createArrayComponent();
        case helpers_1.ComponentType.static: return Static_1.createStaticComponent(child);
        case helpers_1.ComponentType.fn: return Fn_1.createFnComponent(child);
        // no default is intentional: getType always returns a type
    }
};
