"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.renderArray = void 0;
var tslib_1 = require("tslib");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var _1 = require(".");
function renderArray(component, xmlns) {
    // NOTE: this code block is similar to Array Component logic
    // TODO: refactor
    var HTMLElementStreams = new Map();
    return component.items$.pipe(operators_1.startWith(null), operators_1.pairwise(), operators_1.switchMap(function (_a) {
        var _b = tslib_1.__read(_a, 2), prev = _b[0], curr = _b[1];
        // shortcut
        // if curr array is empty
        if (curr.length == 0) {
            HTMLElementStreams.clear();
            return rxjs_1.of([]);
        }
        // removing obsolete keys
        if (prev && prev.length != 0) {
            for (var prevIndex = 0; prevIndex < prev.length; prevIndex++) {
                var shouldRemove = true;
                var prevKey = prev[prevIndex].key;
                for (var currIndex = 0; currIndex < curr.length; currIndex++) {
                    if (prevKey == curr[currIndex].key) {
                        shouldRemove = false;
                        break;
                    }
                }
                if (shouldRemove) {
                    var domStream = HTMLElementStreams.get(prevKey);
                    domStream.component.destroy$.next(void 0);
                    domStream.destroy$.next(void 0);
                    HTMLElementStreams.delete(prevKey);
                }
            }
        }
        curr.forEach(function (entry) {
            var key = entry.key, component = entry.component;
            if (HTMLElementStreams.has(key)) {
                return;
            }
            var result$ = new rxjs_1.ReplaySubject(1);
            var destroy$ = new rxjs_1.Subject();
            _1.renderComponent(component, xmlns)
                .pipe(operators_1.map(
            // NOTE: casting ICompiledComponent to IRenderElement here
            //       currently array child cannot be another array
            function (renderElement) { return ({ key: key, renderElement: renderElement }); }), operators_1.takeUntil(destroy$))
                .subscribe(result$);
            HTMLElementStreams.set(key, { component: component, result$: result$, destroy$: destroy$ });
        });
        return rxjs_1.combineLatest.apply(void 0, tslib_1.__spread(curr.map(function (_a) {
            var key = _a.key;
            return HTMLElementStreams.get(key).result$;
        })));
    }));
}
exports.renderArray = renderArray;
