import { isFunction } from '../helpers/isFunction';
const ELEMENT_TYPE = 're-element';
const Element = (type, props) => {
    const elementName = isFunction(type) ? type['displayName'] || type.name : type;
    return ({ _n: elementName,
        _type: ELEMENT_TYPE,
        type,
        props
    });
};
export const isElement = (value) => {
    return value && value._type == ELEMENT_TYPE;
};
const EMPTY_CHILDREN = [];
export const createElement = (type, props, ...children) => {
    if (props == null) {
        props = Object.create(null);
    }
    props.children = children || EMPTY_CHILDREN;
    return Element(type, props);
};
