import { Subject } from 'rxjs';
import { switchMap, take, takeUntil } from 'rxjs/operators';
import { DynamicEntry } from '../DynamicEntry';
import { ComponentType } from './helpers';
export function createObservableComponent() {
    const update$ = new Subject();
    const destroy$ = new Subject();
    const dynamicChild = DynamicEntry();
    destroy$.pipe(take(1))
        .subscribe(dynamicChild.destroy$);
    update$
        .pipe(switchMap(a => a), takeUntil(destroy$))
        .subscribe(dynamicChild.update$);
    return {
        type: ComponentType.observable,
        update$,
        destroy$,
        result$: dynamicChild.result$
    };
}
