import { combineLatest, ReplaySubject, Subject } from 'rxjs';
import { filter, map, take, takeUntil } from 'rxjs/operators';
import { DynamicEntry } from '../DynamicEntry';
import { ComponentType } from './helpers';
export const createStaticComponent = (element) => {
    const update$ = new ReplaySubject(1);
    const destroy$ = new Subject();
    const element$ = new Subject();
    const dynamicChildren = element.props.children
        .map(() => DynamicEntry());
    destroy$.pipe(take(1)).subscribe(() => {
        dynamicChildren.forEach(child => child.destroy$.next(void 0));
        element$.complete();
    });
    dynamicChildren.forEach((child, i) => {
        update$.pipe(map(update => update.props.children[i]), takeUntil(destroy$)).subscribe(child.update$);
    });
    combineLatest(update$.pipe(map(definition => definition.props.ref), filter(x => !!x)), element$).pipe(takeUntil(destroy$)).subscribe(([ref, element]) => {
        ref.next(element);
    });
    const change$ = update$.pipe(map(definition => definition.props), takeUntil(destroy$));
    return {
        type: ComponentType.static,
        update$,
        element$,
        definition: element,
        dynamicChildren,
        change$,
        destroy$,
    };
};
