import { ReplaySubject, Subject } from 'rxjs';
import { take, takeUntil } from 'rxjs/operators';
import { createComponent } from './component';
import { isElement } from './Element';
import { getType } from './component/helpers';
var NULL_CHILD_STUB = Object.create(null);
export var DynamicEntry = function () {
    var update$ = new Subject();
    var result$ = new ReplaySubject(1);
    var destroy$ = new Subject();
    var component;
    var prev = NULL_CHILD_STUB;
    destroy$.pipe(take(1)).subscribe(function () {
        if (component) {
            component.destroy$.next(void 0);
        }
    });
    update$.pipe(takeUntil(destroy$))
        .subscribe(function (curr) {
        // create a new component if:
        // - there were no prev value
        // - different data types of children
        // - different types of elements (leaf / array / static / observable / fn)
        // - keys mismatch
        // - xmlns mismatch
        // - number of children mismatch
        if (prev === NULL_CHILD_STUB
            || getType(prev) != getType(curr)
            || (isElement(curr) && isElement(prev) && (prev.type !== curr.type
                || !Object.is(prev.props.key, curr.props.key)
                || !Object.is(prev.props.xmlns, curr.props.xmlns)
                || prev.props.children.length !== curr.props.children.length))) {
            if (component) {
                component.destroy$.next(void 0);
            }
            component = createComponent(curr);
            result$.next(component);
        }
        component.update$.next(curr);
        prev = curr;
    });
    return {
        update$: update$,
        result$: result$.pipe(takeUntil(destroy$)),
        destroy$: destroy$
    };
};
