import { isFunction } from '../helpers/isFunction';
var ELEMENT_TYPE = 're-element';
var Element = function (type, props) {
    var elementName = isFunction(type) ? type['displayName'] || type.name : type;
    return ({ _n: elementName,
        _type: ELEMENT_TYPE, type: type,
        props: props
    });
};
export var isElement = function (value) {
    return value && value._type == ELEMENT_TYPE;
};
var EMPTY_CHILDREN = [];
export var createElement = function (type, props) {
    var children = [];
    for (var _i = 2; _i < arguments.length; _i++) {
        children[_i - 2] = arguments[_i];
    }
    if (props == null) {
        props = Object.create(null);
    }
    props.children = children || EMPTY_CHILDREN;
    return Element(type, props);
};
