import { Subject } from 'rxjs';
import { switchMap, take, takeUntil } from 'rxjs/operators';
import { DynamicEntry } from '../DynamicEntry';
import { ComponentType } from './helpers';
export function createObservableComponent() {
    var update$ = new Subject();
    var destroy$ = new Subject();
    var dynamicChild = DynamicEntry();
    destroy$.pipe(take(1))
        .subscribe(dynamicChild.destroy$);
    update$
        .pipe(switchMap(function (a) { return a; }), takeUntil(destroy$))
        .subscribe(dynamicChild.update$);
    return {
        type: ComponentType.observable,
        update$: update$,
        destroy$: destroy$,
        result$: dynamicChild.result$
    };
}
