import { __read } from "tslib";
import { combineLatest, ReplaySubject, Subject } from 'rxjs';
import { filter, map, take, takeUntil } from 'rxjs/operators';
import { DynamicEntry } from '../DynamicEntry';
import { ComponentType } from './helpers';
export var createStaticComponent = function (element) {
    var update$ = new ReplaySubject(1);
    var destroy$ = new Subject();
    var element$ = new Subject();
    var dynamicChildren = element.props.children
        .map(function () { return DynamicEntry(); });
    destroy$.pipe(take(1)).subscribe(function () {
        dynamicChildren.forEach(function (child) { return child.destroy$.next(void 0); });
        element$.complete();
    });
    dynamicChildren.forEach(function (child, i) {
        update$.pipe(map(function (update) { return update.props.children[i]; }), takeUntil(destroy$)).subscribe(child.update$);
    });
    combineLatest(update$.pipe(map(function (definition) { return definition.props.ref; }), filter(function (x) { return !!x; })), element$).pipe(takeUntil(destroy$)).subscribe(function (_a) {
        var _b = __read(_a, 2), ref = _b[0], element = _b[1];
        ref.next(element);
    });
    var change$ = update$.pipe(map(function (definition) { return definition.props; }), takeUntil(destroy$));
    return {
        type: ComponentType.static,
        update$: update$,
        element$: element$,
        definition: element,
        dynamicChildren: dynamicChildren,
        change$: change$,
        destroy$: destroy$,
    };
};
