import { createArrayComponent } from './Array';
import { createFnComponent } from './Fn';
import { ComponentType, getType } from './helpers';
import { createLeafComponent } from './Leaf';
import { createObservableComponent } from './Observable';
import { createStaticComponent } from './Static';
export * from './helpers';
// A component listens to definition updates
// and maps that to self updates and children updates
export var createComponent = function (child) {
    var type = getType(child);
    switch (type) {
        case ComponentType.leaf: return createLeafComponent(child);
        case ComponentType.observable: return createObservableComponent();
        case ComponentType.array: return createArrayComponent();
        case ComponentType.static: return createStaticComponent(child);
        case ComponentType.fn: return createFnComponent(child);
        // no default is intentional: getType always returns a type
    }
};
