import { __read, __spread } from "tslib";
import { combineLatest, of, ReplaySubject, Subject } from 'rxjs';
import { map, pairwise, startWith, switchMap, takeUntil } from 'rxjs/operators';
import { renderComponent } from '.';
export function renderArray(component, xmlns) {
    // NOTE: this code block is similar to Array Component logic
    // TODO: refactor
    var HTMLElementStreams = new Map();
    return component.items$.pipe(startWith(null), pairwise(), switchMap(function (_a) {
        var _b = __read(_a, 2), prev = _b[0], curr = _b[1];
        // shortcut
        // if curr array is empty
        if (curr.length == 0) {
            HTMLElementStreams.clear();
            return of([]);
        }
        // removing obsolete keys
        if (prev && prev.length != 0) {
            for (var prevIndex = 0; prevIndex < prev.length; prevIndex++) {
                var shouldRemove = true;
                var prevKey = prev[prevIndex].key;
                for (var currIndex = 0; currIndex < curr.length; currIndex++) {
                    if (prevKey == curr[currIndex].key) {
                        shouldRemove = false;
                        break;
                    }
                }
                if (shouldRemove) {
                    var domStream = HTMLElementStreams.get(prevKey);
                    domStream.component.destroy$.next(void 0);
                    domStream.destroy$.next(void 0);
                    HTMLElementStreams.delete(prevKey);
                }
            }
        }
        curr.forEach(function (entry) {
            var key = entry.key, component = entry.component;
            if (HTMLElementStreams.has(key)) {
                return;
            }
            var result$ = new ReplaySubject(1);
            var destroy$ = new Subject();
            renderComponent(component, xmlns)
                .pipe(map(
            // NOTE: casting ICompiledComponent to IRenderElement here
            //       currently array child cannot be another array
            function (renderElement) { return ({ key: key, renderElement: renderElement }); }), takeUntil(destroy$))
                .subscribe(result$);
            HTMLElementStreams.set(key, { component: component, result$: result$, destroy$: destroy$ });
        });
        return combineLatest.apply(void 0, __spread(curr.map(function (_a) {
            var key = _a.key;
            return HTMLElementStreams.get(key).result$;
        })));
    }));
}
