import { map } from 'rxjs/operators';
import { updateDomChildNodesPipe } from '../../dom/UpdateDomChildNodesPipe';
import { createComponent, ComponentType } from '../component';
import { renderArray } from './Array';
import { renderFn } from './Fn';
import { renderLeaf } from './Leaf';
import { renderObservable } from './Observable';
import { renderStatic } from './Static';
export var render = function (definition, target) {
    var root = createComponent(definition);
    var subscription = renderRootComponent(root, target)
        .subscribe();
    root.update$.next(definition);
    // TODO: add memory leak test
    //       unsubscription might not spread up the tree
    return subscription;
};
function renderRootComponent(component, target) {
    return renderComponent(component, null).pipe(map(function (el) { return [el]; }), updateDomChildNodesPipe(target));
}
export function renderComponent(component, xmlns) {
    if (component.type == ComponentType.leaf) {
        return renderLeaf(component);
    }
    else if (component.type == ComponentType.fn) {
        return renderFn(component, xmlns);
    }
    else if (component.type == ComponentType.static) {
        return renderStatic(component, xmlns);
    }
    else if (component.type == ComponentType.observable) {
        return renderObservable(component, xmlns);
    }
    else if (component.type == ComponentType.array) {
        return renderArray(component, xmlns);
    }
    throw 'Unknown component type';
}
