import { Observable, Subject } from 'rxjs';
import { IChild } from './component';
declare const ELEMENT_TYPE = "re-element";
export interface IElement<A extends Function | string> {
    _n: string;
    _type: typeof ELEMENT_TYPE;
    type: A;
    props: IProps;
}
export declare type ElementKeyType = boolean | number | string | Symbol;
export interface IProps {
    key?: ElementKeyType;
    ref?: Subject<HTMLElement>;
    children?: (Observable<Element> | IElement<any>)[];
    [key: string]: any;
}
export declare const isElement: (value: IChild) => value is IElement<any>;
export declare const createElement: (type: any, props: any, ...children: any[]) => IElement<any>;
export {};
//# sourceMappingURL=Element.d.ts.map