import { Observable, Subject } from 'rxjs';
import { IElement } from '../Element';
import { ILeafComponent } from './Leaf';
import { IStaticComponent } from './Static';
import { IObservableComponent } from './Observable';
import { IFnComponent } from './Fn';
import { IArrayComponent } from './Array';
export declare type IChild = null | number | string | IElement<any> | Array<IElement<any>> | Observable<any>;
export interface IBasicComponent {
    update$: Subject<IChild>;
    destroy$: Subject<void>;
}
export declare type IComponent = ILeafComponent | IStaticComponent | IObservableComponent | IFnComponent | IArrayComponent;
export declare enum ComponentType {
    leaf = "leaf",
    fn = "fn",
    array = "array",
    observable = "observable",
    static = "static"
}
export declare function getType(child: IChild): ComponentType;
//# sourceMappingURL=helpers.d.ts.map